﻿#targetengine "ChangeNumbersInText";
//  Скрипт для изменения числовых значений в тексте
// (c) Eugenyus, 2010-2016, v3.1, Eugenyus@mail.ru
// http://eugenyus.rudtp.ru/ru/ChangeNumbersInText
/* modified 2023 - Скрипт для изменения в заданном диапазоне числовых значений в выделенном тексте 
*/

var w = new Window ("palette","меняем числа в квадратных скобках");
w.orientation = "row";
w.alignChildren = "left";
var myP = w.add ("panel");
myP.orientation = "row";
var myR = myP.add ("group");
myR.alignChildren = "left";
myR.orientation = "column";
var r1 = myR.add ("radiobutton", undefined, "увеличить");
var r2 = myR.add ("radiobutton", undefined, "уменьшить");
r1.value = "true";

var myR1 = myP.add ("group");
myR1.add("statictext",undefined," от ");
var minNum = myR1.add ("edittext",undefined,"0");
minNum.characters = 5;
myR1.add("statictext",undefined," до ");
var maxNum = myR1.add ("edittext",undefined,"10000");

var myR2 = myP.add ("group");
myR2.add("statictext",undefined," на ");
var myNum = myR2.add ("edittext",undefined,"1");
myNum.characters = 2;

var myButGroup = myP.add("group");
myButGroup.orientation = "column";
var mySB = myButGroup.add("button",undefined,"Выполнить");

mySB.onClick = function () {main(r2.value, minNum.text, maxNum.text, myNum.text)};

w.show();


function main(r2, minNum, maxNum, myNum){

  try { var mySel = app.activeDocument.selection[0]; } catch (e) { alert("Выделите текст"); exit(); }
  
  try {
    app.activeDocument.characterStyles.add({name: "ref"}); // Создание символьного стиля
    } catch (error) {};
    app.findGrepPreferences = app.changeGrepPreferences = null;
    app.findGrepPreferences.findWhat = "\\[.+?\\]"; // Поиск сносок в квадратных скобках.
    app.changeGrepPreferences.appliedCharacterStyle = "ref"; // Присваиваение найденному символьного стиля
    app.changeGrep();
    app.findGrepPreferences = app.changeGrepPreferences = null;
    app.findGrepPreferences.findWhat = "(?<!\\d)\\d+?(?!\\d)";
    app.findGrepPreferences.appliedCharacterStyle = "ref"; // Поиск чисел только в пределах символьного стиля
    var myF = mySel.findGrep(true);
    myNum = Number(myNum);
    if (r2 == true) { myNum = 0 - myNum; }
    for (i = 0; i < myF.length; i++) {
        if (Number(myF[i].contents) > Number(minNum) && Number(myF[i].contents) < maxNum) {
        myF[i].contents = String(Number(myF[i].contents) + myNum);
        }
    }
    try {
        app.activeDocument.characterStyles.item("ref").remove(); // Удаление символьного стиля
        } catch (error) {};
}